#!/usr/bin/perl

# ----------------------------------------------------------------------------------
#   iono-affils.pl v1.2
#
#   outputs an affil list based off contents of a "group/affils" directory in which
#   group/pre dirs are sub-directories (so isn't suitable for all sites, designed
#   for single affiled section sites, eg mp3)
#
#   args: none.
# ----------------------------------------------------------------------------------

# path to your group dir
my $groupdir = "/glftpd/site/groups";

# array with directories to exclude from output, add what you want here, or
# comment it out completely.
my @excluded = ("STAFF", "SITEOP");

# whether or not to print group list with basic formatting (eg grp, grp, grp.)
my $comma = 1;

# header of output
my $header = "[SITE-AFFILS] ";	# leave a space at the end

#########################################################################################
my $msg, $count = 0; $msg = $header; my @rawgrpary; my $count = 0; my $group; my $i;

opendir(GRPDIR, $groupdir) || die "ERROR: Can't open dir \"$groupdir\" ('$!'),  check configuration!\n";

while (defined($group = readdir(GRPDIR))) {
        (@rawgrpary[$count] = $group, $count++) unless (($group eq ".") || ($group eq "..") || (groupmatch($group) == 1));
}
my @temp;
for (@rawgrpary) { push (@temp, "\U$_") }
@grpary = @rawgrpary[ sort { $temp[$a] cmp $temp[$b] } 0..$#rawgrpary];
my $i = 1;

foreach $group (@grpary) {
	if ($comma) {
		if ($i == @grpary) { $msg .= "$group. " }
		else { $msg .= "$group, " }
		$i++;
	} else { $msg .= "$group " }
}

$msg .= "($count Groups)";
print "$msg\n";

# matches input group against excluded array
sub groupmatch {
        foreach $exgrp (@excluded) {
                return 1 unless ($exgrp ne $group);
        }
        return 0;
}
